package org.bonitasoft.connector;

import org.bonitasoft.engine.connector.AbstractConnector;
import org.bonitasoft.engine.connector.ConnectorValidationException;

public abstract class AbstractBonitasoftConnectorMergePDFImpl extends
		AbstractConnector {

	protected final static String LISTDOCUMENTSTOMERGE_INPUT_PARAMETER = "listDocumentsToMerge";
	protected final static String PDFNAME1_INPUT_PARAMETER = "pdfName1";
	protected final static String PDFNAME2_INPUT_PARAMETER = "pdfName2";
	protected final static String PROCESSINSTANCEID_INPUT_PARAMETER = "processInstanceId";
	protected final static String LOGS_INPUT_PARAMETER = "logs";
	protected final String OUTPUTDOCUMENT_OUTPUT_PARAMETER = "outputDocument";

	protected final java.util.List getListDocumentsToMerge() {
		return (java.util.List) getInputParameter(LISTDOCUMENTSTOMERGE_INPUT_PARAMETER);
	}

	protected final java.lang.String getPdfName1() {
		return (java.lang.String) getInputParameter(PDFNAME1_INPUT_PARAMETER);
	}

	protected final java.lang.String getPdfName2() {
		return (java.lang.String) getInputParameter(PDFNAME2_INPUT_PARAMETER);
	}

	protected final java.lang.Long getProcessInstanceId() {
		return (java.lang.Long) getInputParameter(PROCESSINSTANCEID_INPUT_PARAMETER);
	}

	protected final java.lang.Boolean getLogs() {
		return (java.lang.Boolean) getInputParameter(LOGS_INPUT_PARAMETER);
	}

	protected final void setOutputDocument(
			org.bonitasoft.engine.bpm.document.DocumentValue outputDocument) {
		setOutputParameter(OUTPUTDOCUMENT_OUTPUT_PARAMETER, outputDocument);
	}

	@Override
	public void validateInputParameters() throws ConnectorValidationException {
		try {
			getListDocumentsToMerge();
		} catch (ClassCastException cce) {
			throw new ConnectorValidationException(
					"listDocumentsToMerge type is invalid");
		}
		try {
			getPdfName1();
		} catch (ClassCastException cce) {
			throw new ConnectorValidationException("pdfName1 type is invalid");
		}
		try {
			getPdfName2();
		} catch (ClassCastException cce) {
			throw new ConnectorValidationException("pdfName2 type is invalid");
		}
		try {
			getProcessInstanceId();
		} catch (ClassCastException cce) {
			throw new ConnectorValidationException(
					"processInstanceId type is invalid");
		}
		try {
			getLogs();
		} catch (ClassCastException cce) {
			throw new ConnectorValidationException("logs type is invalid");
		}

	}

}
