package org.bonitasoft.connector;

import org.bonitasoft.engine.connector.AbstractConnector;
import org.bonitasoft.engine.connector.ConnectorValidationException;

public abstract class AbstractRetrieveEventByRangeImpl extends
		AbstractConnector {

	protected final static String APPLICATIONNAME_INPUT_PARAMETER = "applicationName";
	protected final static String AGENDAID_INPUT_PARAMETER = "agendaId";
	protected final static String SERVICEACCOUNTID_INPUT_PARAMETER = "serviceAccountId";
	protected final static String P12SERVICEACCOUNTFILE_INPUT_PARAMETER = "p12ServiceAccountFile";
	protected final static String SERVICEACCOUNTUSER_INPUT_PARAMETER = "serviceAccountUser";
	protected final static String BEGINDATE_INPUT_PARAMETER = "beginDate";
	protected final static String ENDDATE_INPUT_PARAMETER = "endDate";
	protected final String LISTEVENTS_OUTPUT_PARAMETER = "listEvents";

	protected final java.lang.String getApplicationName() {
		return (java.lang.String) getInputParameter(APPLICATIONNAME_INPUT_PARAMETER);
	}

	protected final java.lang.String getAgendaId() {
		return (java.lang.String) getInputParameter(AGENDAID_INPUT_PARAMETER);
	}

	protected final java.lang.String getServiceAccountId() {
		return (java.lang.String) getInputParameter(SERVICEACCOUNTID_INPUT_PARAMETER);
	}

	protected final java.lang.String getP12ServiceAccountFile() {
		return (java.lang.String) getInputParameter(P12SERVICEACCOUNTFILE_INPUT_PARAMETER);
	}

	protected final java.lang.String getServiceAccountUser() {
		return (java.lang.String) getInputParameter(SERVICEACCOUNTUSER_INPUT_PARAMETER);
	}

	protected final java.lang.String getBeginDate() {
		return (java.lang.String) getInputParameter(BEGINDATE_INPUT_PARAMETER);
	}

	protected final java.lang.String getEndDate() {
		return (java.lang.String) getInputParameter(ENDDATE_INPUT_PARAMETER);
	}

	protected final void setListEvents(java.util.List listEvents) {
		setOutputParameter(LISTEVENTS_OUTPUT_PARAMETER, listEvents);
	}

	@Override
	public void validateInputParameters() throws ConnectorValidationException {
		try {
			getApplicationName();
		} catch (ClassCastException cce) {
			throw new ConnectorValidationException(
					"applicationName type is invalid");
		}
		try {
			getAgendaId();
		} catch (ClassCastException cce) {
			throw new ConnectorValidationException("agendaId type is invalid");
		}
		try {
			getServiceAccountId();
		} catch (ClassCastException cce) {
			throw new ConnectorValidationException(
					"serviceAccountId type is invalid");
		}
		try {
			getP12ServiceAccountFile();
		} catch (ClassCastException cce) {
			throw new ConnectorValidationException(
					"p12ServiceAccountFile type is invalid");
		}
		try {
			getServiceAccountUser();
		} catch (ClassCastException cce) {
			throw new ConnectorValidationException(
					"serviceAccountUser type is invalid");
		}
		try {
			getBeginDate();
		} catch (ClassCastException cce) {
			throw new ConnectorValidationException("beginDate type is invalid");
		}
		try {
			getEndDate();
		} catch (ClassCastException cce) {
			throw new ConnectorValidationException("endDate type is invalid");
		}

	}

}
